<?php

// register and enqueue CSS styles
function kanso_sd_theme_styles_scripts () {
	
	wp_register_style('theme',get_stylesheet_directory_uri().'/style.css', array(), null, 'all');
	wp_register_style('responsive',get_template_directory_uri().'/responsive.css', array(), null, 'all');
	wp_register_style('orbit',get_template_directory_uri().'/scripts/orbit/orbit-1.2.3.css', array(), null, 'all');
	wp_register_style('fontawesome',get_template_directory_uri().'/includes/font-awesome/css/font-awesome.min.css', array(), null, 'all');
	
	wp_enqueue_style('responsive');
	wp_enqueue_style('theme');
	wp_enqueue_style('orbit');
	wp_enqueue_style('fontawesome');
	
	wp_register_script('fitvids', get_template_directory_uri() . '/scripts/fitvids/jquery.fitvids.js', array('jquery'), false, true);
	wp_register_script('orbitslider', get_template_directory_uri() . '/scripts/orbit/jquery.orbit-1.2.3.js', array('jquery'), '1.2.3', false);
	wp_register_script('isotope', get_template_directory_uri() . '/scripts/isotope/jquery.isotope.min.js', array('jquery'), false, true);
	wp_register_script('retina', get_template_directory_uri() . '/scripts/retina/retina.js', array('jquery'), false, true);
	wp_register_script('smoothscroll', get_template_directory_uri() . '/scripts/smooth-scroll/jquery.smooth-scroll.js', array('jquery'), false, true);

	wp_enqueue_script('isotope');
	wp_enqueue_script('orbitslider');
	wp_enqueue_script('fitvids');
	wp_enqueue_script('retina');
	wp_enqueue_script('smoothscroll');

}
add_action('wp_enqueue_scripts', 'kanso_sd_theme_styles_scripts');

function kanso_sd_load_admin_style() {
        wp_register_style( 'kanso_sd_admin_css', get_template_directory_uri() . '/admin-style.css', array(), null, 'all' );
        wp_enqueue_style( 'kanso_sd_admin_css' );
}
add_action( 'admin_enqueue_scripts', 'kanso_sd_load_admin_style' );

function kanso_sd_colorpicker_init () {
	
	wp_register_style('colorpicker',get_template_directory_uri().'/scripts/colorpicker/css/colorpicker.css', array(), false, 'all');
	wp_enqueue_style('colorpicker');

	wp_register_script('colorpickerjs', get_template_directory_uri() . '/scripts/colorpicker/js/colorpicker.js', array('jquery'), false, true);
	wp_enqueue_script('colorpickerjs');

}
add_action( 'admin_enqueue_scripts', 'kanso_sd_colorpicker_init' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Set the content width
function kanso_sd_theme_adjust_content_width() {
	if ( ! isset( $content_width ) ) {
    	$content_width = 4000;
	}
}
add_action( 'template_redirect', 'kanso_sd_theme_adjust_content_width' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// enables widgetized sidebars
if ( function_exists('register_sidebar') )

// Sidebar Widgets
// Location: the sidebar
register_sidebar(array('name'=>'Sidebar',
	'id' => 'sidebar-1',
	'before_widget' => '<div class="widget-area widget-sidebar %2$s">',
	'after_widget' => '<div class="clearleft"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Footer Widgets
// Location: at the top of the footer, above the copyright
register_sidebar(array('name'=>'Footer',
	'id' => 'sidebar-2',
	'before_widget' => '<div class="widget-area widget-footer %2$s">',
	'after_widget' => '</div>',
	'before_title' => '<h4>',
	'after_title' => '</h4><div class="clear"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Activate included plugins on theme activation
require_once dirname( __FILE__ ) . '/includes/class-tgm-plugin-activation.php';
add_action( 'tgmpa_register', 'kanso_sd_register_required_plugins' );
function kanso_sd_register_required_plugins() {
    $plugins = array( 
		array(
            'name'                  => 'Revolution Slider', 
            'slug'                  => 'revslider', 
            'source'                => get_template_directory() . '/includes/plugins/revslider.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),
        array(
            'name'                  => 'Advanced Recent Posts', 
            'slug'                  => 'advanced-recent-posts', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-recent-posts.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Contact Form', 
            'slug'                  => 'contact-form', 
            'source'                => get_template_directory() . '/includes/plugins/contact-form.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Advanced SEO', 
            'slug'                  => 'advanced-seo', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-seo.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Custom Sidebars', 
            'slug'                  => 'custom-sidebars', 
            'source'                => get_template_directory() . '/includes/plugins/custom-sidebars.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Shortcodes', 
            'slug'                  => 'shortcodes', 
            'source'                => get_template_directory() . '/includes/plugins/shortcodes.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),array(
            'name'                  => 'Social media Widget', 
            'slug'                  => 'social-media-widget', 
            'source'                => get_template_directory() . '/includes/plugins/social-media-widget.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
        ),array(
            'name'                  => 'Twitter Widget', 
            'slug'                  => 'twitter-widget', 
            'source'                => get_template_directory() . '/includes/plugins/twitter-widget.zip', 
            'required'              => false, 
            'force_activation'      => false, 
            'force_deactivation'    => true, 
		)
    );
  
    $config = array(
        'domain'            => 'satori',           
        'default_path'      => '',                          
        'parent_menu_slug'  => 'themes.php',         
        'parent_url_slug'   => 'themes.php',        
        'menu'              => 'install-required-plugins',   
        'has_notices'       => true,                        
        'is_automatic'      => true,            
        'message'           => '',               
        'strings'           => array(
            'page_title'                                => __( 'Install Required Plugins', 'satori' ),
            'menu_title'                                => __( 'Install Required Plugins', 'satori' ),
            'installing'                                => __( 'Installing Plugin: %s', 'satori' ), // %1$s = plugin name
            'oops'                                      => __( 'Something went wrong with the plugin API.', 'satori' ),
            'notice_can_install_required'               => _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_install_recommended'            => _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends installing the following pre-packaged plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_install'                     => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
            'notice_can_activate_required'              => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_activate_recommended'           => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_activate'                    => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
            'notice_ask_to_update'                      => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_update'                      => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
            'install_link'                              => _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
            'activate_link'                             => _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
            'return'                                    => __( 'Return to Required Plugins Installer', 'satori' ),
            'plugin_activated'                          => __( 'Plugin activated successfully.', 'satori' ),
            'complete'                                  => __( 'All plugins installed and activated successfully. %s', 'satori' ) // %1$s = dashboard link
        )
    );
 
    tgmpa( $plugins, $config );
 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add RSS links
add_theme_support( 'automatic-feed-links' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds the post thumbnail to the RSS feed
function kanso_sd_get_the_content_with_formatting ($kanso_sd_more_link_text = '(more...)', $kanso_sd_stripteaser = 0, $kanso_sd_more_file = '') {
	$kanso_sd_content = get_the_content($kanso_sd_more_link_text, $kanso_sd_stripteaser, $kanso_sd_more_file);
	$kanso_sd_content = apply_filters('the_content', $kanso_sd_content);
	$kanso_sd_content = str_replace(']]>', ']]&gt;', $kanso_sd_content);
	return $kanso_sd_content;
}

function kanso_sd_cwc_rss_post_thumbnail($kanso_sd_content) {
	global $post;
	if(has_post_thumbnail($post->ID)) {
		$kanso_sd_content = '<p>' . get_the_post_thumbnail($post->ID) .
		'</p>' . kanso_sd_get_the_content_with_formatting();
	}
	return $kanso_sd_content;
}
add_filter('the_excerpt_rss', 'kanso_sd_cwc_rss_post_thumbnail');
add_filter('the_content_feed', 'kanso_sd_cwc_rss_post_thumbnail');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add portfolio projects to primary RSS feed

function kanso_sd_feed_request($kanso_sd_qv) { 
	if ( isset($kanso_sd_qv['feed']) && !isset($kanso_sd_qv['post_type']) )
		$kanso_sd_qv['post_type'] = array('post', 'project'); 
	return $kanso_sd_qv; 
} 
add_filter('request', 'kanso_sd_feed_request');

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom menu support
add_theme_support( 'menus' );
if ( function_exists( 'register_nav_menus' ) ) {
	register_nav_menus(
		array(
		  'header-menu' => 'Main Menu'
		)
	);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add WYSIWYG editor styles
function kanso_sd_add_editor_styles() {
    add_editor_style( 'custom-editor-style.css' );
}
add_action( 'init', 'kanso_sd_add_editor_styles' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Removes Trackbacks from the comment count
add_filter('get_comments_number', 'kanso_sd_comment_count', 0);
function kanso_sd_comment_count( $kanso_sd_count ) {
	if ( ! is_admin() ) {
		global $id;
		$kanso_sd_getcomm = get_comments('status=approve&post_id=' . $id);
		$kanso_sd_sepcomm = separate_comments($kanso_sd_getcomm);
		$kanso_sd_comments_by_type = &$kanso_sd_sepcomm;
		return count($kanso_sd_comments_by_type['comment']);
	} else {
		return $kanso_sd_count;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Invite rss subscribers to comment
function kanso_sd_rss_comment_footer($kanso_sd_content) {
	if (is_feed()) {
		if (comments_open()) {
			$kanso_sd_content .= 'Comments are open! <a href="'.get_permalink().'">Add yours!</a>';
		}
	}
	return $kanso_sd_content;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom excerpt ellipses for 2.9+
function kanso_sd_custom_excerpt_more($more) {
	return __('Read More', 'satori').'&raquo;';
}
add_filter('excerpt_more', 'kanso_sd_custom_excerpt_more');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// No more jumping for read more link
function kanso_sd_no_more_jumping($post) {
	if(isset($post->ID)) { return '<a href="'.get_permalink($post->ID).'" class="read-more">'.'&nbsp; Continue Reading &raquo;'.'</a>'; }
}
add_filter('excerpt_more', 'kanso_sd_no_more_jumping');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds excerpts to pages
add_action('init', 'kanso_sd_pe_init');
function kanso_sd_pe_init() {
	add_post_type_support( 'page', 'excerpt' );
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds a class to the post if there is a thumbnail
function kanso_sd_has_thumb_class($classes) {
	global $post;
	if( has_post_thumbnail($post->ID) ) { 
		$classes[] = 'has_thumb'; 
	}
	return $classes;
}
add_filter('post_class', 'kanso_sd_has_thumb_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add taxonomies to post class
function kanso_sd_tax_class($kanso_sd_taxclass) {
	global $post;
	$kanso_sd_cats = get_the_terms($post->ID, 'category');
	if ( $kanso_sd_cats && ! is_wp_error( $kanso_sd_cats ) ) {
		foreach ($kanso_sd_cats as $kanso_sd_cat) {
			$kanso_sd_taxclass[] = strtolower($kanso_sd_cat->name);	
		}
	}
	$kanso_sd_tags = get_the_terms($post->ID, 'post_tag');
	if ( $kanso_sd_tags && ! is_wp_error( $kanso_sd_tags ) ) {
		foreach ($kanso_sd_tags as $kanso_sd_tag) {
			$kanso_sd_taxclass[] = strtolower($kanso_sd_tag->name);	
		}
	}
	$kanso_sd_tagports = get_the_terms($post->ID, 'tagportfolio');
	if ( $kanso_sd_tagports && ! is_wp_error( $kanso_sd_tagports ) ) {
		foreach ($kanso_sd_tagports as $kanso_sd_tagport) {
			$kanso_sd_taxclass[] = strtolower($kanso_sd_tagport->name);
			$kanso_sd_taxclass[] = strtolower($kanso_sd_tagport->slug);	
		}
	}
	return $kanso_sd_taxclass;
}
add_filter('post_class', 'kanso_sd_tax_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add the .post class to portfolio items
function kanso_sd_overall_post_class($kanso_sd_classes) {
	global $post;
	if( get_post_type($post->ID) == 'project' ) { $kanso_sd_classes[] = 'post'; }
		return $kanso_sd_classes;
}
add_filter('post_class', 'kanso_sd_overall_post_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Make theme available for translation
// Translations can be filed in the /languages/ directory
load_theme_textdomain('satori', get_template_directory() . '/languages');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Enable threaded comments
function enable_threaded_comments(){
if (!is_admin()) {
	if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
		wp_enqueue_script('comment-reply');
	}
}
add_action('get_header', 'enable_threaded_comments');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add fancybox support
include_once( get_template_directory(). '/includes/easy-fancybox/easy-fancybox.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add a pager
require_once( get_template_directory(). '/includes/pager/pager.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add dropdown menus for mobile screens
include_once( get_template_directory(). '/includes/dropdown-menus/dropdown-menus.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Initialize the metabox class
add_action( 'init', 'kanso_sd_initialize_cmb_meta_boxes', 9999 );
function kanso_sd_initialize_cmb_meta_boxes() {
	if ( !class_exists( 'cmb_Meta_Box' ) ) {
		require_once( get_template_directory(). '/includes/metaboxes/init.php' );
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Option Tree integration
include_once( get_template_directory(). '/includes/option-tree/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom Tag Cloud 
add_filter('widget_tag_cloud_args','set_largest_tags');
function set_largest_tags($kanso_sd_args) {
$kanso_sd_args = array('largest'    => 14);
return $kanso_sd_args; }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Create portfolio 
add_action('init', 'kanso_sd_project_custom_init');      

function kanso_sd_project_custom_init() 
{  
	// The following is all the names, in our tutorial, we use "Project"
	$labels = array(
		'name' => _x('Projects', 'post type general name', 'satori'),
		'singular_name' => _x('Project', 'post type singular name', 'satori'),
		'all_items' => __('All Projects','satori'),
		'add_new' => _x('Add New', 'project', 'satori'),
		'add_new_item' => __('Add New Project', 'satori'),
		'edit_item' => __('Edit Project', 'satori'),
		'new_item' => __('New Project', 'satori'),
		'view_item' => __('View Project', 'satori'),
		'search_items' => __('Search Projects', 'satori'),
		'not_found' =>  __('No projects found', 'satori'),
		'not_found_in_trash' => __('No projects found in Trash', 'satori'),
		'parent_item_colon' => '',
		'menu_name' => __('Portfolio', 'satori')
	);
	
	// Some arguments and in the last line 'supports', we say to WordPress what features are supported on the Project post type
	$args = array(
		'labels' => $labels,
		'public' => true,
		'publicly_queryable' => true,
		'show_ui' => true,
		'show_in_menu' => true,
		'query_var' => true,
		'rewrite' => true,
		'capability_type' => 'post',
		'has_archive' => true,
		'hierarchical' => false,
		'menu_position' => null,
		'supports' => array('title','editor','author','thumbnail','excerpt','comments','post-formats')
	);
	
	// We call this function to register the custom post type
	register_post_type('project',$args);
	
	// Initialize Taxonomy Labels
	$labels = array(
		'name' => _x( 'Types', 'taxonomy general name' , 'satori'),
		'singular_name' => _x( 'Type', 'taxonomy singular name', 'satori' ),
		'search_items' =>  __( 'Search Types' , 'satori'),
		'all_items' => __( 'All Types', 'satori' ),
		'parent_item' => __( 'Parent Type', 'satori' ),
		'parent_item_colon' => __( 'Parent Type:', 'satori' ),
		'edit_item' => __( 'Edit Types', 'satori' ),
		'update_item' => __( 'Update Type', 'satori' ),
		'add_new_item' => __( 'Add New Type', 'satori' ),
		'new_item_name' => __( 'New Type Name', 'satori' ),
	);
	
	// Register Custom Taxonomy
	register_taxonomy('tagportfolio',array('project'), array(
		'hierarchical' => true, // define whether to use a system like tags or categories
		'labels' => $labels,
		'show_ui' => true,
		'query_var' => true,
		'rewrite' => array( 'slug' => 'tag-portfolio' ),
	));
}  

add_filter('post_updated_messages', 'kanso_sd_project_updated_messages');

function kanso_sd_project_updated_messages( $messages ) {
  global $post, $post_ID;

  $messages['project'] = array(
	0 => '', // Unused. Messages start at index 1.
	1 => sprintf( __('Project updated. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	2 => __('Custom field updated.', 'satori'),
	3 => __('Custom field deleted.', 'satori'),
	4 => __('Project updated.', 'satori'),
	/* translators: %s: date and time of the revision */
	5 => isset($_GET['revision']) ? sprintf( __('Project restored to revision from %s', 'satori'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	6 => sprintf( __('Project published. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	7 => __('Project saved.', 'satori'),
	8 => sprintf( __('Project submitted. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	9 => sprintf( __('Project scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview project</a>', 'satori'),
	  // translators: Publish box date format, see http://php.net/date
	  date_i18n( __( 'M j, Y @ G:i' , 'satori'), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	10 => sprintf( __('Project draft updated. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );

  return $messages;
}

if ( function_exists( 'add_theme_support' ) ) {  
add_theme_support(  'post-thumbnails' );
} 

if ( function_exists( 'kanso_sd_get_option_tree' ) && is_string ( kanso_sd_get_option_tree( 'boxdim' ) ) )  { 
	$kanso_sd_boxdim = kanso_sd_get_option_tree( 'boxdim' );
	if ( is_string(kanso_sd_get_option_tree( 'boxmar' )) ) { 
		$kanso_sd_largeboxdim = $kanso_sd_boxdim*2 + kanso_sd_get_option_tree( 'boxmar' )*2;
	} else {
		$kanso_sd_largeboxdim = $kanso_sd_boxdim*2 + 32;
	}
} else {
	$kanso_sd_largeboxdim = 552;
}
$kanso_sd_largeboxretina = $kanso_sd_largeboxdim * 2;
if ( function_exists( 'add_image_size' ) ) {
add_image_size( 'square', $kanso_sd_largeboxretina, $kanso_sd_largeboxretina, true ); 
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to posts with layout options 
$kanso_sd_prefix = 'satori_';
$kanso_sd_meta_box = array(
'id' => 'post-layout-choice',
'title' => 'Post Layout',
'page' => 'post',
'context' => 'side',
'priority' => 'core',
'fields' => array(
	array(
		'name' => 'Pick one:',
		'id' => $kanso_sd_prefix . 'post-layout',
		'type' => 'select',
		'options' => array('Right Sidebar','Full Width','Left Sidebar')
	)
)
);

add_action('admin_menu', 'kanso_sd_post_layout_add_box');
// Add meta box
function kanso_sd_post_layout_add_box() {
	global $kanso_sd_meta_box;
	$kanso_sd_types = array('post', 'project');
	foreach ( $kanso_sd_types as $kanso_sd_type ) {
	add_meta_box($kanso_sd_meta_box['id'], $kanso_sd_meta_box['title'], 'kanso_sd_post_layout_show_box', $kanso_sd_type, $kanso_sd_meta_box['context'], $kanso_sd_meta_box['priority']);
	}
}

// Callback function to show fields in meta box
function kanso_sd_post_layout_show_box() {
global $kanso_sd_meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="kanso_sd_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($kanso_sd_meta_box['fields'] as $kanso_sd_field) {
	// get current post meta data
	$kanso_sd_meta = get_post_meta($post->ID, $kanso_sd_field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $kanso_sd_field['id'], '">', $kanso_sd_field['name'], '</label></th>',
			'<td>';
	switch ($kanso_sd_field['type']) {
		case 'text':
			echo '<input type="text" name="', $kanso_sd_field['id'], '" id="', $kanso_sd_field['id'], '" value="', $kanso_sd_meta ? $kanso_sd_meta : $kanso_sd_field['std'], '" size="30" style="width:97%" />', '<br />', $kanso_sd_field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $kanso_sd_field['id'], '" id="', $kanso_sd_field['id'], '" cols="60" rows="4" style="width:97%">', $kanso_sd_meta ? $kanso_sd_meta : $kanso_sd_field['std'], '</textarea>', '<br />', $kanso_sd_field['desc'];
			break;
		case 'select':
			echo '<select name="', $kanso_sd_field['id'], '" id="', $kanso_sd_field['id'], '" width="80%">';
			foreach ($kanso_sd_field['options'] as $kanso_sd_option) {
				echo '<option ', $kanso_sd_meta == $kanso_sd_option ? ' selected="selected"' : '', '>', $kanso_sd_option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($kanso_sd_field['options'] as $kanso_sd_option) {
				echo '<input type="radio" name="', $kanso_sd_field['id'], '" value="', $kanso_sd_option['value'], '"', $kanso_sd_meta == $kanso_sd_option['value'] ? ' checked="checked"' : '', ' />', $kanso_sd_option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $kanso_sd_field['id'], '" id="', $kanso_sd_field['id'], '"', $kanso_sd_meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'kanso_sd_save_data');
// Save data from meta box
function kanso_sd_save_data($kanso_sd_post_id) {
global $kanso_sd_meta_box;
// verify nonce
$kanso_sd_post_nonce = ( isset( $_POST[ 'kanso_sd_meta_box_nonce' ] ) ? $_POST[ 'kanso_sd_meta_box_nonce' ] : false );
if (!wp_verify_nonce($kanso_sd_post_nonce, basename(__FILE__))) {
	return $kanso_sd_post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $kanso_sd_post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $kanso_sd_post_id)) {
		return $kanso_sd_post_id;
	}
} elseif (!current_user_can('edit_post', $kanso_sd_post_id)) {
	return $kanso_sd_post_id;
}
foreach ($kanso_sd_meta_box['fields'] as $kanso_sd_field) {
	$kanso_sd_old = get_post_meta($kanso_sd_post_id, $kanso_sd_field['id'], true);
	$kanso_sd_new = $_POST[$kanso_sd_field['id']];
	if ($kanso_sd_new && $kanso_sd_new != $kanso_sd_old) {
		update_post_meta($kanso_sd_post_id, $kanso_sd_field['id'], $kanso_sd_new);
	} elseif ('' == $kanso_sd_new && $kanso_sd_old) {
		delete_post_meta($kanso_sd_post_id, $kanso_sd_field['id'], $kanso_sd_old);
	}
}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Get URL of first image in a post
function kanso_sd_catch_first_image() {
global $post, $posts;
$kanso_sd_first_img = '';
ob_start();
ob_end_clean();
$kanso_sd_output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $kanso_sd_matches);
$kanso_sd_first_img = $kanso_sd_matches [1] [0];
return $kanso_sd_first_img;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom search form
function kanso_sd_search_form( $kanso_sd_form ) {
$kanso_sd_form = '<form role="search" method="get" id="searchform" action="' . home_url( '/' ) . '" >
<div><input type="text" value="'.__('Find..', 'satori').'" name="s" id="s" />
<input type="submit" id="searchsubmit" value="" />
</div>
</form>';
return $kanso_sd_form;
}
add_filter( 'get_search_form', 'kanso_sd_search_form' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Post format support
add_theme_support( 'post-formats', array( 'aside', 'gallery', 'quote', 'video', 'link', 'image' ) );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Meta box for setting the header image in pages
function kanso_sd_page_header_image_metabox( $kanso_sd_meta_boxes ) {
	$kanso_sd_prefix = '_cmb_'; // Prefix for all fields
	$kanso_sd_meta_boxes[] = array(
		'id' => 'page_header_image_metabox',
		'title' => 'Page Settings',
		'pages' => array('page', 'project'), // post type
		'context' => 'normal',
		'priority' => 'high',
		'show_names' => true, // Show field names on the left
		'fields' => array(
			array(
				'name' => 'Header image',
				'desc' => 'Upload the header image or enter a URL',
				'id' => $kanso_sd_prefix . 'image_upload',
				'type' => 'file',
				'save_id' => true, // save ID using true
				'allow' => array( 'url', 'attachment' ) // limit to just attachments with array( 'attachment' )
			),
			array(
				'name' => 'Header height',
				'desc' => 'Set the height of the header image (plain number in pixels, i.e. without the "px"). Default is "300"',
				'id' => $kanso_sd_prefix . 'header_height',
				'type' => 'text_small'
			),
			array(
				'name' => 'Page title above content (if you have a one-page template set for the front page)',
				'desc' => 'Check this if you wish the header of this page to display above the content and not float to the left',
				'id' => $kanso_sd_prefix . 'title_above',
				'type' => 'checkbox'
			),
			array(
				'name' => 'Hide page title',
				'desc' => 'Check this if you wish to hide the page title',
				'id' => $kanso_sd_prefix . 'page_title',
				'type' => 'checkbox'
			),
			array(
				'name' => 'Hide page separator line',
				'desc' => 'Check this if you wish to hide the separator line',
				'id' => $kanso_sd_prefix . 'page_separator',
				'type' => 'checkbox'
			),
			array(
				'name' => 'Page background color',
				'desc' => 'Choose the background color for the page',
				'id' => $kanso_sd_prefix . 'page_background_color',
				'type' => 'text_small'
			),
			array(
				'name' => 'Page background image',
				'desc' => 'Upload the background image for the page',
				'id' => $kanso_sd_prefix . 'page_background_image',
				'type' => 'file',
				'save_id' => true, // save ID using true
				'allow' => array( 'url', 'attachment' ) // limit to just attachments with array( 'attachment' )
			),
			array(
				'name' => 'Page background repeat',
				'desc' => 'Choose if you want to repeat the background image (i.e. create a pattern)',
				'id' => $kanso_sd_prefix . 'page_background_repeat',
				'type' => 'radio',
				'options' => array(
					array('name' => 'Repeat', 'value' => 'repeat'),
					array('name' => 'Do not repeat', 'value' => 'norepeat')
				)
			),
			array(
				'name' => 'Page heading text color',
				'desc' => 'Choose the heading text color for this particular page',
				'id' => $kanso_sd_prefix . 'page_heading_color',
				'type' => 'text_small'
			),
			array(
				'name' => 'Page body text color',
				'desc' => 'Choose the body text color for this particular page',
				'id' => $kanso_sd_prefix . 'page_body_color',
				'type' => 'text_small'
			),
			array(
				'name' => 'Parallax header',
				'desc' => 'Enable parallax effect for page header image',
				'id' => $kanso_sd_prefix . 'page_parallax_header',
				'type' => 'checkbox'
			),
			array(
				'name' => 'Parallax background',
				'desc' => 'Enable parallax effect for page background',
				'id' => $kanso_sd_prefix . 'page_parallax_bck',
				'type' => 'checkbox'
			)
		)
	);
	return $kanso_sd_meta_boxes;
}
add_filter( 'cmb_meta_boxes', 'kanso_sd_page_header_image_metabox' );

?>